package org.wso2.carbon.lcm.core.impl;

import org.wso2.carbon.lcm.core.beans.AvailableTransitionBean;
import org.wso2.carbon.lcm.core.beans.CheckItemBean;
import org.wso2.carbon.lcm.core.beans.CustomCodeBean;
import org.wso2.carbon.lcm.core.beans.InputBean;
import org.wso2.carbon.lcm.core.beans.PermissionBean;

import java.util.ArrayList;
import java.util.List;

/**
 * This is life cycle state class and life cycle state related information such as
 * next executables and possible state changes etc should stored with this class.
 */
public class LifecycleState {

    private String lcName;
    private String state;
    // Lifecycle id generated by framework which used as the reference in order to maintain mapping between
    // external asset types. This will be a UUID
    private String lifecycleId;
    private List<CheckItemBean> checkItemBeanList;
    private List<InputBean> inputBeanList;
    private List<CustomCodeBean> customCodeBeanList;
    private List<AvailableTransitionBean> availableTransitionBeanList;
    private List<PermissionBean> permissionBeanList;

    public LifecycleState() {
        checkItemBeanList = new ArrayList<>();
        inputBeanList = new ArrayList<>();
        customCodeBeanList = new ArrayList<>();
        availableTransitionBeanList = new ArrayList<>();
        permissionBeanList = new ArrayList<>();
    }

    public String getLcName() {
        return lcName;
    }

    public void setLcName(String lcName) {
        this.lcName = lcName;
    }

    /**
     * @return current state of life cycle state
     */
    public String getState() {
        return state;
    }

    /**
     * @param state the state of current lifecycle state object.
     */
    public void setState(String state) {
        this.state = state;
    }

    public String getLifecycleId() {
        return lifecycleId;
    }

    public void setLifecycleId(String lifecycleId) {
        this.lifecycleId = lifecycleId;
    }

    public List<CheckItemBean> getCheckItemBeanList() {
        return checkItemBeanList;
    }

    public void setCheckItemBeanList(List<CheckItemBean> checkItemBeanList) {
        this.checkItemBeanList = checkItemBeanList;
    }

    public List<InputBean> getInputBeanList() {
        return inputBeanList;
    }

    public void setInputBeanList(List<InputBean> inputBeanList) {
        this.inputBeanList = inputBeanList;
    }

    public List<CustomCodeBean> getCustomCodeBeanList() {
        return customCodeBeanList;
    }

    public void setCustomCodeBeanList(List<CustomCodeBean> customCodeBeanList) {
        this.customCodeBeanList = customCodeBeanList;
    }

    public List<AvailableTransitionBean> getAvailableTransitionBeanList() {
        return availableTransitionBeanList;
    }

    public void setAvailableTransitionBeanList(List<AvailableTransitionBean> availableTransitionBeanList) {
        this.availableTransitionBeanList = availableTransitionBeanList;
    }

    public List<PermissionBean> getPermissionBeanList() {
        return permissionBeanList;
    }

    public void setPermissionBeanList(List<PermissionBean> permissionBeanList) {
        this.permissionBeanList = permissionBeanList;
    }

    //TODO Add allowed check items and other information should be here.

}
